-- 
-- AdvancedAnimalTable 
-- 
-- @Interface: ...
-- @Author: kevink98 
-- @Date: 19.01.2018
-- @Version: 1.0.0.0
-- 
-- @Support: LS-Modcompany
-- 

g_gui:loadProfiles(g_currentModDirectory .. "animals_scripts/AdvancedAnimalTableProfiles.xml");	
local xmlFile = loadXMLFile("Temp", g_currentModDirectory .. "animals_scripts/AdvancedAnimalTable.xml");
local slider = SliderElement:new(InGameMenu);
slider:loadFromXML(xmlFile, "GuiElement");
g_gui:loadGuiRec(xmlFile, "GuiElement", slider, InGameMenu);
delete(xmlFile);
	
g_gui.guis["InGameMenu"].elements[2].elements[1].elements[2].elements[6]:addElement(slider);
g_gui.guis["InGameMenu"].elements[2].elements[1].elements[2]:updateAbsolutePosition();

AdvancedAnimalTable = {};
addModEventListener(AdvancedAnimalTable);
function AdvancedAnimalTable:update()
	if self.firstUpdate == nil then		
		slider["onChangedCallback"] = InGameMenu.onChangedAnimalSlider;
		local maxS = 0;
		if g_currentMission ~= nil then
			for k, husbandries in pairs(g_currentMission.husbandries) do
				if husbandries.hasStatistics then
					maxS = maxS + 1;
				end
			end;
		end;
		slider:setMinValue((maxS - 2) * -1);
		slider:setMaxValue(-1);
		g_inGameMenu.animalSliderPos =  -1;
		g_inGameMenu.animalSliderPosNum = maxS - 2;
		self.firstUpdate = true;
		for k,v in pairs(g_modEventListeners) do
			if v == AdvancedAnimalTable then
				table.remove(g_modEventListeners, k);
			end;
		end;
	end;
end;
function AdvancedAnimalTable:loadMap() end;
function AdvancedAnimalTable:delete() end;
function AdvancedAnimalTable:deleteMap() end;
function AdvancedAnimalTable:draw() end;
function AdvancedAnimalTable:keyEvent() end;
function AdvancedAnimalTable:mouseEvent() end;

InGameMenu.onChangedAnimalSlider = function (self, currentValue)
	if g_inGameMenu.animalBarElementSize ~= nil then
		g_inGameMenu.animalSliderPos = currentValue;
		local data = g_inGameMenu:getAnimalData()
		g_inGameMenu:setupAnimalPage(data);
		g_inGameMenu:updateAnimalPage(data);
	end;
end;

InGameMenu.getAnimalData = function(self)
    local animals = {};
    if g_currentMission ~= nil then
        for k, husbandries in pairs(g_currentMission.husbandries) do
            if husbandries.hasStatistics then
                local animal = {};
                animal.name = k;
                animal.attrGeneral, animal.attrSpecific, animal.attrInput, animal.attrHelp = husbandries:getDataAttributes();
                table.insert(animals, animal);
            end
        end;
    end	
	local showAnimals = {};
	local num = 0;
	for k,v in pairs(animals) do
		if k >= (g_inGameMenu.animalSliderPos * -1) then
			table.insert(showAnimals, v);
			num = num + 1;
			if num == 3 then
				break;
			end;
		end;
	end;	
    return showAnimals;
end;